/* MAST - MÓDULO TRAMECAD PARA MODELAGEM DE POSTES DE SEÇÃO POLIGONAL

 1 - mast ( número de faces, raio base, raio topo, altura, espessura, 
          cota de base )

 2 - pol ( nº de faces, raio )

 3 - polplates ( número, raio, largura, espessura, altura, z coord)

 4 - polplates_vertice ( número, raio, largura, espessura, altura, z coord)

*/

//---------------------------------------------------------------
// DESENHA POLÍGONO REGULAR 2D PARA EXTRUSÃO
//---------------------------------------------------------------

module pol(n, r){
     angles=[ for (i = [0:n-1]) i*(360/n) ];
     coords=[ for (th=angles) [r*cos(th), r*sin(th)] ];
     polygon(coords);
 }



//---------------------------------------------------------------
// MAST
// MÓDULO DE POSTE POLIGONAL COM SEÇÃO CONSTANTE OU VARIÁVEL
//---------------------------------------------------------------
module mast (n, rb, rt, h, t,p){
esc = rt/rb;
difference(){
translate([0,0,p])
linear_extrude (height = h, center = false, convexity = 0, scale=esc, twist = 0)
pol(n,rb);

translate([0,0,p-1])
linear_extrude (height = h+2, center = false, convexity = 0, scale=esc, twist = 0)
pol(n,rb-t);
}
}

//---------------------------------------------------------------
// POLPLATES
// CHAPAS VERTICAIS DE LIGAÇÃO ENTRE MÓDULOS CENTRADAS NAS FACES
//---------------------------------------------------------------

module polplates (n , r, bp, tp, hp, z){
     if (n <= 1 ){ n = 2;}
       for (i = [0:n-1])
        { angle= i * (360/n);
        rotate(angle)
          translate([0,r-tp,z])
            cube(size=[bp,tp,hp],center=true);
               }    
}

//---------------------------------------------------------------
// POLPLATES_VERTICE
// CHAPAS DOBRADAS LIGAÇÃO ENTRE MÓDULOS CENTRADAS NOS VÉRTICES
//---------------------------------------------------------------
module polplates_vertice (n , r, bp, tp, hp, z){
     if (n <= 1 ){ n = 2;}
     ang = 360/n;
     deltax = (r+tp) * sin(ang/2);
     deltay = (r+tp) * cos(ang/2);
       for (i = [0:n-1])
        {
          angle= i * (360/n);
        rotate(angle)
    translate([-deltax,deltay,z]){
        union (){
             translate([0,-tp,0])
             cube(size=[bp,tp,hp],center=false);           
             rotate(180+ang)
             cube(size=[bp,tp,hp],center=false);
           }           
    }    
  }
}

//---------------------------------------------------------------
//color("white")
//mast(18,450,450,500,5,0);
//polplates_two(18,450,50,5,500,0);